
/*  Various programs concerning the El-Fish .fsh file format.
    Copyright (C) 2004 Vidar Holen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


package holen.vidar.elfish;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class Animate extends JFrame implements KeyListener {
    Image[] imgs;
    int scale=4;
    int num=0;
    int push=0;
    int count=0;

    public Animate(String fish) {
        super("Fishy");
        MediaTracker mt=new MediaTracker(this);
        imgs=new Image[300];
        String fn;
        while(new File(fn=(fish+ExtractFrames.pad(num,4)+".png")).exists()) {
            imgs[num]=Toolkit.getDefaultToolkit().getImage(fn);
            mt.addImage(imgs[num],0);
            num++;
        }
        System.out.println("Stopped on "+fn);
        addKeyListener(this);
        
        setSize(640,480);
        setVisible(true);

        try {
            mt.waitForAll();
        } catch(Exception e) {}

        /*
        new Thread() {
            public void run() {
                while(true) {
                    try {
                        Thread.sleep(20000);
                        repaint();
                    } catch(Exception e) {}
                }
            }
        }.start();
        */
    }
    
    public void keyPressed(KeyEvent e) {
        if(e.getKeyCode()==e.VK_A) scale++;
        else if(e.getKeyCode()==e.VK_Z) scale--;
        else if(e.getKeyCode()==e.VK_LEFT) { push--; count--; }
        else if(e.getKeyCode()==e.VK_RIGHT) { push++; count++; }
        else if(e.getKeyCode()==e.VK_DOWN) { count-=6; }
        else if(e.getKeyCode()==e.VK_UP) { count+=6; }
        else if(e.getKeyCode()==e.VK_SPACE) { System.out.println("---"); }
        else if(e.getKeyCode()==e.VK_Q) count--;
        else if(e.getKeyCode()==e.VK_W) count++;
        else if(e.getKeyCode()==e.VK_R) { count=0; }
        repaint();
    }
    public void keyTyped(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    public void paint(Graphics g) {
        g.clearRect(0,0,getWidth(),getHeight());

        if(false) { 
        int[] list={156,162,168,174,180,186,192};
        int n=list[count%list.length];
        g.drawImage(imgs[n],0,30,
                imgs[n].getWidth(null)*scale,imgs[n].getHeight(null)*scale,null);
        }else { 

        if(count>=num) count=push;
        System.out.println(count);
        g.drawImage(imgs[count],0,30,
                imgs[count].getWidth(null)*scale,imgs[count].getHeight(null)*scale,null);
        }
//        count+=6;
    }
    public static void main(String[] args) {
        new Animate(args[0]);
    }
}

    

