
/*  Various programs concerning the El-Fish .fsh file format.
    Copyright (C) 2004 Vidar Holen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


package holen.vidar.elfish;

import java.io.*;

public class CountFrames { 
    public static void main(String[] args) throws Exception {
        RandomAccessFile raf=new RandomAccessFile(args[0],"r");
        StringBuffer sb=new StringBuffer();

        raf.seek(0x0A);
        for(int i=0; i<8; i++) {
            int c=raf.read();
            if(c==0) break;
            else sb.append((char)c);
        }
        System.out.println("Fish name: "+sb);

        raf.seek(0x8B);
        /*
        int det=iflip(raf.readInt());
        int icon=iflip(raf.readInt());
        int frames=iflip(raf.readInt());
        */
        int[] features=new int[26];
        for(int i=0; i<features.length; i++) {
            features[i]=iflip(raf.readInt());
        }

        for(int j=0; j<features.length; j++) {
            if(features[j]==0) continue;
            System.out.println();
            p("Dumping "+j+" from",features[j]);
            int n=0;
            int[] fd=new int[8];
            while(features[j]!=0) {
                raf.seek(features[j]);
                for(int i=0; i<5; i++)
                    fd[i]=iflip(raf.readInt());
                for(int i=5; i<8; i++) 
                    fd[i]=sflip(raf.readShort());
                int w=sflip(raf.readShort());
                int h=sflip(raf.readShort());

                System.out.println("#"+n+" Len="+h(fd[0])+"\t p="+h(fd[2])+"\t n="+h(fd[3])+"\t "+w+","+h+": "+fd[1]+"\t "+fd[5]+" +"+(short)fd[6]+","+fd[7]);
                features[j]=fd[3];
                n++;
            }
        }
    }
    public static String h(int n) {
        return Integer.toHexString(n);
    }
    public static void p(String s, int n) {
        System.out.println(s+" "+h(n)+" ("+n+")");
    }
    public static int iflip(int n) {
        return flip(n,4);
    }
    public static int sflip(int n) {
        return flip(n,2);
    }
    public static int flip(int n, int b) {
        int a=0;
        for(int i=0; i<b; i++) {
            a=(a<<8) | (n&0xFF);
            n=n>>8;
        }
        return a;
    }
}

