
/*  Various programs concerning the El-Fish .fsh file format.
    Copyright (C) 2004 Vidar Holen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


package holen.vidar.elfish;


/*
Program for viewing random sequences of bytes as an image
of varying width. For my elfish .fsh hacking project.

copyleft Vidar Holen, vidar@vidarholen.net
*/


import java.awt.*;
import java.io.*;
import java.awt.event.*;

public class TryFrame extends Frame implements KeyListener, MouseListener, WindowListener {
	int push=0;
	int width=120;
	int multiplier=8;
	char[] b;
    java.awt.Color[] palette;

    public void windowClosing(WindowEvent e) { System.exit(0); }
    public void windowClosed(WindowEvent e) {}
    public void windowOpened(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}


	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
	

	public void keyTyped(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {
		if(e.getKeyCode()==e.VK_UP) width++; else
		if(e.getKeyCode()==e.VK_DOWN) width--; else
		if(e.getKeyCode()==e.VK_RIGHT) push++; else //=(push+1)%width; else
		if(e.getKeyCode()==e.VK_LEFT) push--; else //=(push-1)%width; else
		if(e.getKeyCode()==e.VK_A) multiplier*=2; else
		if(e.getKeyCode()==e.VK_Z) if(multiplier>1) multiplier/=2;
	       repaint();
	}

	public TryFrame(char[] c, String cp) throws Exception {
		b=c;
                loadPalette(cp);
		setSize(640,480);
		setVisible(true);
		addKeyListener(this);
		addMouseListener(this);
        addWindowListener(this);
	}

        public void loadPalette(String file) throws Exception{
                        palette=new java.awt.Color[256];
                        BufferedReader in=new BufferedReader(new
FileReader(file));
                        String s;
                        while((s=in.readLine())!=null) {
                                int div=s.indexOf(";");
                                int idx=Integer.parseInt(s.substring(0,div));
                                int val=Integer.parseInt(s.substring(div+1),16);
                                palette[idx]=new java.awt.Color(val);
                        }

        }


        public void paint(Graphics g) {
            System.out.println(width+" width, "+Integer.toHexString(push)+" push");
            int row,col;
            int hc;
            int w,h,ch=0, p=0;

            for(int frame=0; frame<push; frame++) {
                p+=28;
                w=b[p] | (b[p+1]<<8);
                h=b[p+2] | (b[p+3]<<8);
                System.out.println("Width "+w+", Height "+h);
                p+=4;
                row=0; col=0;

                while(ch<h-1) {
                    int tw=b[p] | b[p+1]<<8;
                    p+=2;
                    int pos=b[p] | b[p+1]<<8;
                    p+=2; 
                    if(pos<0x8000) {
                        row++; ch++;
                        System.out.println(ch);
                    } else {
                        pos=(1<<16) - pos;
                    }
                    col=pos;

                    if(frame!=push-1) p+=tw;
                    else 
                    for(int i=0; i<tw; i++) {
                        g.setColor(palette[(int)b[p++]]);
                        g.fillRect((col)*multiplier,(row)*multiplier+30,multiplier,multiplier);
                        col++; 
                    }
                    System.out.println(Integer.toHexString(p+0x1F0A)+", "+Integer.toHexString(p));
                }
            }
        }
	public static void main(String[] args) throws Exception {
		DataInputStream dis=new DataInputStream(System.in);
		char[] b=new char[20000];
        for(int i=0; i<0x1EEE; i++) dis.read();
        try {
            for(int i=0; i<b.length; i++) {
                b[i]=(char)dis.read();
            }
        } catch(Exception e) { e.printStackTrace(System.err); }
//		for(int i=0; i<b.length; i++) b[i]=(char)(b[i]==0xAF?b[i]*4:0);
		TryFrame dv=new TryFrame(b,args[0]);

	}
}


